//===================================================================
// pas2000w.c
//-------------------------------------------------------------------
//
// PA-S2000 Wrapper
//
//===================================================================
#define STRICT

#include <windows.h>
#include <tchar.h>

#include "pas2000w.h"	// PA-S2000


typedef BOOL  WINAPI (*TPas2000GetVersion) ( PDWORD pdwDrvVer, PDWORD pdwDllVer );
typedef BOOL  WINAPI (*TPas2000Create) ( PWORD pwDeviceNo, HWND hWnd, UINT uWMBase );
typedef BOOL  WINAPI (*TPas2000Close) ( WORD wDeviceNo );
typedef BOOL  WINAPI (*TPas2000GetDevInfo) ( WORD wDeviceNo, TDEVINFO *pDevInfo );
typedef BOOL  WINAPI (*TPas2000GetMemSize) ( WORD wDeviceNo, PDWORD pdwMemSize );
typedef BOOL  WINAPI (*TPas2000SetMode) ( WORD wDeviceNo, TSETMODE *pSetMode );
typedef BOOL  WINAPI (*TPas2000StartSampling) ( WORD wDeviceNo, DWORD dwInitArg );
typedef BOOL  WINAPI (*TPas2000StopSampling) ( WORD wDeviceNo );
typedef BOOL  WINAPI (*TPas2000GetStatus) ( WORD wDeviceNo, PDWORD pdwStatus, PDWORD pdwNumData, PVOID pvInitArg );
typedef BOOL  WINAPI (*TPas2000GetData) ( WORD wDeviceNo, DWORD dwNumData, PDWORD pdwData );
typedef DWORD WINAPI (*TPas2000GetLastError) ( WORD wDeviceNo );

static HMODULE hDLL = NULL;

// DLLGNX|[g֐AhX̊i[ϐ
static TPas2000GetVersion 		pPas2000GetVersion;
static TPas2000Create 			pPas2000Create;
static TPas2000Close 			pPas2000Close;
static TPas2000GetDevInfo 		pPas2000GetDevInfo;
static TPas2000GetMemSize 		pPas2000GetMemSize;
static TPas2000SetMode 			pPas2000SetMode;
static TPas2000StartSampling 	pPas2000StartSampling;
static TPas2000StopSampling 	pPas2000StopSampling;
static TPas2000GetStatus 		pPas2000GetStatus;
static TPas2000GetData 			pPas2000GetData;
static TPas2000GetLastError 	pPas2000GetLastError;

static BOOL Pas2000wGetDllExportFunc();

//-------------------------------------------------------------------
// 		DLL[h(񃍁[h̓G[Ƃ)
// 		
// ߂l	 True
//			s False
//-------------------------------------------------------------------
BOOL Pas2000wDllOpen( void )
{
	if ( hDLL != NULL )
		return FALSE;
	hDLL = (HMODULE)LoadLibrary( PAS2000_DLL_NAME );
	if ( hDLL == NULL )
		return FALSE;
	if ( Pas2000wGetDllExportFunc() == FALSE ) {
		Pas2000wDllClose();	// DLLGNX|[g֐擾ɎŝDLLN[Y
		return FALSE;
	}
	return TRUE;
}
//-------------------------------------------------------------------
// 		DLLA[h(A[h̓G[Ƃ)
// 		
// ߂l	 True
//			s False
//-------------------------------------------------------------------
BOOL Pas2000wDllClose( void )
{
	if ( hDLL == NULL )
		return TRUE;
	if ( FreeLibrary( hDLL ) == TRUE ) {
		hDLL = NULL;
		return TRUE;
	}
	return FALSE;
}
//-------------------------------------------------------------------
// 		o[W擾
// 		pdwDrvVer   hCõo[Wi[̈ւ̃|C^
//			pdwDllVer   DLL̃o[Wi[̈ւ̃|C^
// ߂l	 True
//			s False
//-------------------------------------------------------------------
BOOL Pas2000wGetVersion( PDWORD pdwDrvVer, PDWORD pdwDllVer )
{
	if ( hDLL == NULL )
		return FALSE;

	return (*pPas2000GetVersion)( pdwDrvVer, pdwDllVer );
}
//-------------------------------------------------------------------
// 		foCX̌
// 		pwDeviceNo  gpfoCX̃foCXʔԍi[̈ւ
//						|C^
//			hWnd        DLLo郁bZ[W󂯎EBhẼnh
//	        uWMBase     o郁bZ[WID̃x[Xl
// ߂l	 True
//			s False
//-------------------------------------------------------------------
BOOL Pas2000wCreate( PWORD pwDeviceNo, HWND hWnd, UINT uWMBase )
{
	if ( hDLL == NULL )
		return FALSE;

	return (*pPas2000Create)( pwDeviceNo, hWnd, uWMBase );
}
//-------------------------------------------------------------------
// 		foCX̊J
// 		wDeviceNo   ΏۃfoCX̃foCXʔԍ
// ߂l	 True
//			s False
//-------------------------------------------------------------------
BOOL Pas2000wClose( WORD wDeviceNo )
{
	if ( hDLL == NULL )
		return FALSE;

	return (*pPas2000Close)( wDeviceNo );
}
//-------------------------------------------------------------------
// 		foCX̎擾
// 		wDeviceNo   ΏۃfoCX̃foCXʔԍ
//			pDevInfo    foCXi[\̂ւ̃|C^
// ߂l	 True
//			s False
//-------------------------------------------------------------------
BOOL Pas2000wGetDevInfo( WORD wDeviceNo, TDEVINFO *pDevInfo )
{
	if ( hDLL == NULL )
		return FALSE;

	return (*pPas2000GetDevInfo)( wDeviceNo, pDevInfo );
}
//-------------------------------------------------------------------
// 		TCY̎擾
// 		wDeviceNo   ΏۃfoCX̃foCXʔԍ
//			pdwMemSize  Ă郁TCYi[̈ւ̃|C^
// ߂l	 True
//			s False
//-------------------------------------------------------------------
BOOL Pas2000wGetMemSize( WORD wDeviceNo, PDWORD pdwMemSize )
{
	if ( hDLL == NULL )
		return FALSE;

	return (*pPas2000GetMemSize)( wDeviceNo, pdwMemSize );
}
//-------------------------------------------------------------------
// 		TvO샂[h̐ݒ
// 		wDeviceNo   ΏۃfoCX̃foCXʔԍ
//			pSetMode    ݒi[Ă\̂̃|C^
// ߂l	 True
//			s False
//-------------------------------------------------------------------
BOOL Pas2000wSetMode( WORD wDeviceNo, TSETMODE *pSetMode )
{
	if ( hDLL == NULL )
		return FALSE;

	return (*pPas2000SetMode)( wDeviceNo, pSetMode );
}
//-------------------------------------------------------------------
// 		TvO̊Jn
// 		wDeviceNo   ΏۃfoCX̃foCXʔԍ
//			dwInitArg	\(0w)
// ߂l	 True
//			s False
//-------------------------------------------------------------------
BOOL Pas2000wStartSampling( WORD wDeviceNo, DWORD dwInitArg )
{
	if ( hDLL == NULL )
		return FALSE;

	return (*pPas2000StartSampling)( wDeviceNo, dwInitArg );
}
//-------------------------------------------------------------------
// 		TvO̒~
// 		wDeviceNo   ΏۃfoCX̃foCXʔԍ
// ߂l	 True
//			s False
//-------------------------------------------------------------------
BOOL Pas2000wStopSampling( WORD wDeviceNo )
{
	if ( hDLL == NULL )
		return FALSE;

	return (*pPas2000StopSampling)( wDeviceNo );
}
//-------------------------------------------------------------------
// 		TvOXe[^X擾
// 		wDeviceNo   ΏۃfoCX̃foCXʔԍ
//			pdwStatus   TvOXe[^X
//			pdwNumData  ǃTvOf[^
//			pvInitArg   \
// ߂l	 True
//			s False
//-------------------------------------------------------------------
BOOL Pas2000wGetStatus( WORD wDeviceNo, PDWORD pdwStatus, PDWORD pdwNumData, PVOID pvInitArg )
{
	if ( hDLL == NULL )
		return FALSE;

	return (*pPas2000GetStatus)( wDeviceNo, pdwStatus, pdwNumData, pvInitArg );
}
//-------------------------------------------------------------------
// 		TvOf[^擾
// 		wDeviceNo   ΏۃfoCX̃foCXʔԍ
//			dwNumData   擾f[^
//			pdwData     擾f[^i[̈ւ̃|C^
// ߂l	 True
//			s False
//-------------------------------------------------------------------
BOOL Pas2000wGetData( WORD wDeviceNo, DWORD dwNumData, PDWORD pdwData )
{
	if ( hDLL == NULL )
		return FALSE;

	return (*pPas2000GetData)( wDeviceNo, dwNumData, pdwData );
}
//-------------------------------------------------------------------
// 		G[R[h̎擾
// 		wDeviceNo   ΏۃfoCX̃foCXʔԍ
// ߂l	G[R[h
//-------------------------------------------------------------------
DWORD Pas2000wGetLastError( WORD wDeviceNo )
{
	if ( hDLL == NULL )
		return PAS2000_ERR_WRAPDLL;

	return (*pPas2000GetLastError)( wDeviceNo );
}

//-------------------------------------------------------------------
// 		DLLGNX|[g֐AhX̎擾
// 		
// ߂l	 TRUE
//			s FALSE
//-------------------------------------------------------------------
static BOOL Pas2000wGetDllExportFunc()
{
	// Pas2000GetVersioñAhX擾
	pPas2000GetVersion = (TPas2000GetVersion)GetProcAddress( hDLL, _T( "Pas2000GetVersion" ) );
	if ( pPas2000GetVersion == NULL )
		return FALSE;
	// Pas2000CreatẽAhX擾
	pPas2000Create = (TPas2000Create)GetProcAddress( hDLL, _T( "Pas2000Create" ) );
	if ( pPas2000Create == NULL )
		return FALSE;
	// Pas2000ClosẽAhX擾
	pPas2000Close = (TPas2000Close)GetProcAddress( hDLL, _T( "Pas2000Close" ) );
	if ( pPas2000Close == NULL )
		return FALSE;
	// Pas2000GetDevInfõAhX擾
	pPas2000GetDevInfo = (TPas2000GetDevInfo)GetProcAddress( hDLL, _T( "Pas2000GetDevInfo" ) );
	if ( pPas2000GetDevInfo == NULL )
		return FALSE;
	// Pas2000GetMemSizẽAhX擾
	pPas2000GetMemSize = (TPas2000GetMemSize)GetProcAddress( hDLL, _T( "Pas2000GetMemSize" ) );
	if ( pPas2000GetMemSize == NULL )
		return FALSE;
	// Pas2000SetModẽAhX擾
	pPas2000SetMode = (TPas2000SetMode)GetProcAddress( hDLL, _T( "Pas2000SetMode" ) );
	if ( pPas2000SetMode == NULL )
		return FALSE;
	// Pas2000StartSampling̃AhX擾
	pPas2000StartSampling = (TPas2000StartSampling)GetProcAddress( hDLL, _T( "Pas2000StartSampling" ) );
	if ( pPas2000StartSampling == NULL )
		return FALSE;
	// Pas2000StopSampling̃AhX擾
	pPas2000StopSampling = (TPas2000StopSampling)GetProcAddress( hDLL, _T( "Pas2000StopSampling" ) );
	if ( pPas2000StopSampling == NULL )
		return FALSE;
	// Pas2000GetStatus̃AhX擾
	pPas2000GetStatus = (TPas2000GetStatus)GetProcAddress( hDLL, _T( "Pas2000GetStatus" ) );
	if ( pPas2000GetStatus == NULL )
		return FALSE;
	// Pas2000GetDatãAhX擾
	pPas2000GetData = (TPas2000GetData)GetProcAddress( hDLL, _T( "Pas2000GetData" ) );
	if ( pPas2000GetData == NULL )
		return FALSE;
	// Pas2000GetLastError̃AhX擾
	pPas2000GetLastError = (TPas2000GetLastError)GetProcAddress( hDLL, _T( "Pas2000GetLastError" ) );
	if ( pPas2000GetLastError == NULL )
		return FALSE;

	return TRUE;	// SĂDLLGNX|[g֐AhX擾
}
